#include "stdafx.h"
#include <iostream>
#include <sstream>
using namespace std;
#include "../symbolTable/VectorSymbolTable.h"
#include "../symbolTable/MapSymbolTable.h"
#include "../symbolTable/SymbolTableSimpleFactory.h"
#include "ISymbolTable.h"
#include "CppUnitTest.h"
using namespace cs242;

using namespace Microsoft::VisualStudio::CppUnitTestFramework;

void someFunction(int someInt, stringstream& out)
{
	out << someInt;
}

void functionFunction(
	void (*aFunction)(int, stringstream&), 
	stringstream& out)
{
	int myInt = 10;
	(*aFunction)(myInt, out);
}

namespace SymbolTableTests
{		
	TEST_CLASS(UnitTest1)
	{
	public:

		TEST_METHOD(passAFunction)
		{
			stringstream theStream;
			functionFunction(someFunction, theStream);
			Assert::AreEqual(string("10"),
				theStream.str());
		}
		
		TEST_METHOD(createVectorSymbolTable)
		{
			// Create an instance of the 
			// VectorSymbolTable
			VectorSymbolTable<int> vTable;
		}

		TEST_METHOD(insertIntoSymbolTable)
		{
			// Create an instance of the 
			// VectorSymbolTable
			VectorSymbolTable<int> vTable;
			vTable.insert("cs242", 10);
			int thingFound;
			bool lookupSuccess =
				vTable.lookup("cs242", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(10, thingFound);
		}

		TEST_METHOD(insertManyIntoSymbolTable)
		{
			// Create an instance of the 
			// VectorSymbolTable
			VectorSymbolTable<int> vTable;
			vTable.insert("cs142", 10);
			vTable.insert("cs241", 11);
			vTable.insert("cs345", 12);
			vTable.insert("cs242", 13);
			vTable.insert("cs141", 14);
			vTable.insert("cs335", 15);
			vTable.insert("cs399", 16);
			int thingFound;
			bool lookupSuccess =
				vTable.lookup("cs242", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(13, thingFound);

			lookupSuccess =
				vTable.lookup("cs141", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(14, thingFound);

			lookupSuccess =
				vTable.lookup("cs142", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(10, thingFound);

			lookupSuccess =
				vTable.lookup("cs241", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(11, thingFound);

			lookupSuccess =
				vTable.lookup("cs345", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(12, thingFound);

			lookupSuccess =
				vTable.lookup("cs335", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(15, thingFound);

		}

		TEST_METHOD(insertIntoMapSymbolTable)
		{
			// Create an instance of the 
			// VectorSymbolTable
			MapSymbolTable <int> vTable;
			vTable.insert("cs242", 10);
			int thingFound;
			bool lookupSuccess =
				vTable.lookup("cs242", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(10, thingFound);
		}

		TEST_METHOD(insertManyIntoMapSymbolTable)
		{
			// Create an instance of the 
			// VectorSymbolTable
			VectorSymbolTable<int> vTable;
			vTable.insert("cs142", 10);
			vTable.insert("cs241", 11);
			vTable.insert("cs345", 12);
			vTable.insert("cs242", 13);
			vTable.insert("cs141", 14);
			vTable.insert("cs335", 15);
			vTable.insert("cs399", 16);
			int thingFound;
			bool lookupSuccess =
				vTable.lookup("cs242", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(13, thingFound);

			lookupSuccess =
				vTable.lookup("cs141", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(14, thingFound);

			lookupSuccess =
				vTable.lookup("cs142", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(10, thingFound);

			lookupSuccess =
				vTable.lookup("cs241", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(11, thingFound);

			lookupSuccess =
				vTable.lookup("cs345", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(12, thingFound);

			lookupSuccess =
				vTable.lookup("cs335", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(15, thingFound);

		}

		TEST_METHOD(insertIntoFactoryMadeST)
		{

			ISymbolTable<int>* symbolTable =
			SymbolTableSimpleFactory::create<int>
				(SymbolTableSimpleFactory::simple);

			symbolTable->insert("cs242", 10);
			int thingFound;
			bool lookupSuccess =
				symbolTable->lookup("cs242", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(10, thingFound);
		}

		TEST_METHOD(insertManyIntoFactorySymbolTable)
		{

			ISymbolTable<int>* symbolTable =
				SymbolTableSimpleFactory::create<int>
				(SymbolTableSimpleFactory::simple);

			symbolTable->insert("cs142", 10);
			symbolTable->insert("cs241", 11);
			symbolTable->insert("cs345", 12);
			symbolTable->insert("cs242", 13);
			symbolTable->insert("cs141", 14);
			symbolTable->insert("cs335", 15);
			symbolTable->insert("cs399", 16);
			int thingFound;
			bool lookupSuccess =
				symbolTable->lookup("cs242", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(13, thingFound);

			lookupSuccess =
				symbolTable->lookup("cs141", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(14, thingFound);

			lookupSuccess =
				symbolTable->lookup("cs142", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(10, thingFound);

			lookupSuccess =
				symbolTable->lookup("cs241", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(11, thingFound);

			lookupSuccess =
				symbolTable->lookup("cs345", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(12, thingFound);

			lookupSuccess =
				symbolTable->lookup("cs335", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(15, thingFound);

		}


		TEST_METHOD(insertIntoComplexFactoryMadeST)
		{
			ISymbolTable<int>* symbolTable =
				SymbolTableSimpleFactory::create<int>
				(SymbolTableSimpleFactory::complex);

			symbolTable->insert("cs242", 10);
			int thingFound;
			bool lookupSuccess =
				symbolTable->lookup("cs242", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(10, thingFound);
		}

		TEST_METHOD(insertManyIntoComplexFactorySymbolTable)
		{
			ISymbolTable<int>* symbolTable =
				SymbolTableSimpleFactory::create<int>
				(SymbolTableSimpleFactory::complex);

			symbolTable->insert("cs142", 10);
			symbolTable->insert("cs241", 11);
			symbolTable->insert("cs345", 12);
			symbolTable->insert("cs242", 13);
			symbolTable->insert("cs141", 14);
			symbolTable->insert("cs335", 15);
			symbolTable->insert("cs399", 16);
			int thingFound;
			bool lookupSuccess =
				symbolTable->lookup("cs242", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(13, thingFound);

			lookupSuccess =
				symbolTable->lookup("cs141", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(14, thingFound);

			lookupSuccess =
				symbolTable->lookup("cs142", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(10, thingFound);

			lookupSuccess =
				symbolTable->lookup("cs241", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(11, thingFound);

			lookupSuccess =
				symbolTable->lookup("cs345", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(12, thingFound);

			lookupSuccess =
				symbolTable->lookup("cs335", thingFound);
			Assert::IsTrue(lookupSuccess);
			Assert::AreEqual(15, thingFound);

		}



	};
}