#pragma once
#include <string>

// An abstract data type is a data type that is 
// defined strictly by the operations that you
// can perform on it.
namespace cs242
{
	template <typename Type>
	class ISymbolTable
	{
	public:
		virtual bool lookup(const std::string& key,
			Type& foundItem) = 0;

		virtual void insert(const std::string& key,
			const Type& payload) = 0;

		virtual ~ISymbolTable() {};
	};
}
