#pragma once
#include <map>
#include <string>
#include "ISymbolTable.h"

namespace cs242
{
	template <typename Type>
	class MapSymbolTable : public ISymbolTable<Type>
	{
	public:
		virtual bool lookup(const std::string& key,
			Type& foundItem)
		{
			bool findSuccessful = 
				symbolTable_.find(key) != 
				symbolTable_.end();

			if (findSuccessful)
			{
				foundItem = symbolTable_[key];
			}
			return findSuccessful;
		}

		virtual void insert(const std::string& key,
			const Type& payload)
		{
			symbolTable_[key] = payload;
		}

		virtual ~MapSymbolTable() {};

	private:
		std::map<std::string, Type> symbolTable_;
	};
}