#pragma once
#include "stdafx.h"
#include "ISymbolTable.h"
#include "VectorSymbolTable.h"
#include "MapSymbolTable.h"
namespace cs242
{
	class SymbolTableSimpleFactory
	{
	public:
		static const std::string simple;
		static const std::string complex;

		template <typename Type>
		static ISymbolTable<Type>* create(
			const std::string& description)
		{
			ISymbolTable<Type>* thingToReturn = 0;

			if (description == simple)
			{
				thingToReturn =
					new VectorSymbolTable<Type>();
			}
			else
			{
				if (description == complex)
				{
					thingToReturn =
						new MapSymbolTable<Type>();
				}
				else
				{
				//	if (description == redBlackTree)
				//	{
				//		thingToReturn =
				//			new RedBlackSymbolTable<Type>();
				//	}
				}
			}
			return thingToReturn;
		}
	};
}
