#pragma once
#include "ISymbolTable.h"
#include <string>
#include <vector>


namespace cs242
{
	template <typename Type>
	class VectorSymbolTable : public ISymbolTable<Type>
	{
	public:

		virtual bool lookup(const std::string& key,
			Type& foundItem);

		virtual void insert(const std::string& key,
			const Type& payload);

	private:
		std::vector< std::pair<std::string, Type> > theTable_;
	};

	template <typename Type>
	bool VectorSymbolTable<Type>::lookup(const std::string& key,
		Type& foundItem)
	{
		int i = 0;
		while (i < theTable_.size()
			&& theTable_[i].first != key)++i;

		if (theTable_[i].first == key)
		{
			foundItem = theTable_[i].second;
		}

		return  theTable_[i].first == key;
	}

	template <typename Type>
	void VectorSymbolTable<Type>::insert(
		const std::string& key,
		const Type& payload)
	{
		theTable_.push_back(
			std::make_pair(key, payload));
	}
}